diff -Naur --no-dereference a/drivers/remoteproc/remoteproc_cdev.c b/drivers/remoteproc/remoteproc_cdev.c
--- a/drivers/remoteproc/remoteproc_cdev.c	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/remoteproc/remoteproc_cdev.c	2025-10-23 09:30:40.286462238 -0400
@@ -18,9 +18,23 @@
 #define NUM_RPROC_DEVICES	64
 static dev_t rproc_major;
 
+struct rproc_cdev {
+	struct rproc *rproc;
+	bool cdev_put_on_release;
+	/* Protects the attachments lists */
+	struct mutex mutex;
+	struct list_head attachments;
+};
+
+struct rproc_cdev_attach {
+	struct dma_buf *dmabuf;
+	struct list_head node;
+};
+
 static ssize_t rproc_cdev_write(struct file *filp, const char __user *buf, size_t len, loff_t *pos)
 {
-	struct rproc *rproc = container_of(filp->f_inode->i_cdev, struct rproc, cdev);
+	struct rproc_cdev *rproc_cdev = filp->private_data;
+	struct rproc *rproc = rproc_cdev->rproc;
 	int ret = 0;
 	char cmd[10];
 
@@ -47,7 +61,8 @@
 
 static long rproc_device_ioctl(struct file *filp, unsigned int ioctl, unsigned long arg)
 {
-	struct rproc *rproc = container_of(filp->f_inode->i_cdev, struct rproc, cdev);
+	struct rproc_cdev *rproc_cdev = filp->private_data;
+	struct rproc *rproc = rproc_cdev->rproc;
 	void __user *argp = (void __user *)arg;
 	s32 param;
 
@@ -56,14 +71,57 @@
 		if (copy_from_user(&param, argp, sizeof(s32)))
 			return -EFAULT;
 
-		rproc->cdev_put_on_release = !!param;
+		rproc_cdev->cdev_put_on_release = !!param;
 		break;
 	case RPROC_GET_SHUTDOWN_ON_RELEASE:
-		param = (s32)rproc->cdev_put_on_release;
+		param = (s32)rproc_cdev->cdev_put_on_release;
 		if (copy_to_user(argp, &param, sizeof(s32)))
 			return -EFAULT;
 
 		break;
+	case RPROC_IOC_DMA_BUF_ATTACH:
+		{
+			struct rproc_dma_buf_attach_data data;
+			struct rproc_cdev_attach *attach;
+			struct dma_buf *dmabuf;
+			dma_addr_t da;
+			int ret;
+
+			if (copy_from_user(&data, (void __user *)arg, _IOC_SIZE(ioctl)))
+				return -EFAULT;
+
+			dmabuf = dma_buf_get(data.fd);
+			if (IS_ERR(dmabuf))
+				return PTR_ERR(dmabuf);
+
+			ret = rproc_attach_dmabuf(rproc, dmabuf);
+			if (ret) {
+				dma_buf_put(dmabuf);
+				return ret;
+			}
+
+			ret = rproc_dmabuf_get_da(rproc, dmabuf, &da);
+			if (ret) {
+				rproc_detach_dmabuf(rproc, dmabuf);
+				dma_buf_put(dmabuf);
+				return ret;
+			}
+			data.da = da;
+
+			/* Save for later removal */
+			attach = kzalloc(sizeof(*attach), GFP_KERNEL);
+			if (!attach) {
+				rproc_detach_dmabuf(rproc, dmabuf);
+				dma_buf_put(dmabuf);
+				return -ENOMEM;
+			}
+			attach->dmabuf = dmabuf;
+			list_add_tail(&attach->node, &rproc_cdev->attachments);
+
+			if (copy_to_user((void __user *)arg, &data, _IOC_SIZE(ioctl)))
+				return -EFAULT;
+		}
+		break;
 	default:
 		dev_err(&rproc->dev, "Unsupported ioctl\n");
 		return -EINVAL;
@@ -72,18 +130,46 @@
 	return 0;
 }
 
-static int rproc_cdev_release(struct inode *inode, struct file *filp)
+static int rproc_cdev_open(struct inode *inode, struct file *file)
 {
 	struct rproc *rproc = container_of(inode->i_cdev, struct rproc, cdev);
+	struct rproc_cdev *rproc_cdev;
+
+	rproc_cdev = kzalloc(sizeof(*rproc_cdev), GFP_KERNEL);
+	if (!rproc_cdev)
+		return -ENOMEM;
+
+	rproc_cdev->rproc = rproc;
+	mutex_init(&rproc_cdev->mutex);
+	INIT_LIST_HEAD(&rproc_cdev->attachments);
+
+	file->private_data = rproc_cdev;
+
+	return 0;
+}
+
+static int rproc_cdev_release(struct inode *inode, struct file *filp)
+{
+	struct rproc_cdev *rproc_cdev = filp->private_data;
+	struct rproc *rproc = rproc_cdev->rproc;
 	int ret = 0;
 
-	if (!rproc->cdev_put_on_release)
-		return 0;
+	if (rproc_cdev->cdev_put_on_release) {
+		if (rproc->state == RPROC_RUNNING)
+			rproc_shutdown(rproc);
+		else if (rproc->state == RPROC_ATTACHED)
+			ret = rproc_detach(rproc);
+	}
 
-	if (rproc->state == RPROC_RUNNING)
-		rproc_shutdown(rproc);
-	else if (rproc->state == RPROC_ATTACHED)
-		ret = rproc_detach(rproc);
+	/* Release all buffers attached with this file */
+	struct rproc_cdev_attach *attach, *atmp;
+	list_for_each_entry_safe(attach, atmp, &rproc_cdev->attachments, node) {
+		rproc_detach_dmabuf(rproc, attach->dmabuf);
+		dma_buf_put(attach->dmabuf);
+		kfree(attach);
+	}
+	mutex_destroy(&rproc_cdev->mutex);
+	kfree(rproc_cdev);
 
 	return ret;
 }
@@ -92,6 +178,7 @@
 	.write = rproc_cdev_write,
 	.unlocked_ioctl = rproc_device_ioctl,
 	.compat_ioctl = compat_ptr_ioctl,
+	.open = rproc_cdev_open,
 	.release = rproc_cdev_release,
 };
 
diff -Naur --no-dereference a/drivers/remoteproc/remoteproc_core.c b/drivers/remoteproc/remoteproc_core.c
--- a/drivers/remoteproc/remoteproc_core.c	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/remoteproc/remoteproc_core.c	2025-10-23 09:30:40.286462238 -0400
@@ -20,6 +20,7 @@
 #include <linux/kernel.h>
 #include <linux/module.h>
 #include <linux/device.h>
+#include <linux/dma-map-ops.h>
 #include <linux/panic_notifier.h>
 #include <linux/slab.h>
 #include <linux/mutex.h>
@@ -895,6 +896,129 @@
 }
 EXPORT_SYMBOL(rproc_add_carveout);
 
+static struct rproc_dmabuf_entry *rproc_find_entry_for_dmabuf(struct rproc *rproc,
+							      struct dma_buf *dmabuf)
+{
+	struct rproc_dmabuf_entry *dmabuf_entry;
+
+	list_for_each_entry(dmabuf_entry, &rproc->dmabufs, node) {
+		if (dmabuf_entry->dmabuf == dmabuf)
+			return dmabuf_entry;
+	}
+
+	return NULL;
+}
+
+/* TODO: Should we map here? */
+int rproc_dmabuf_get_da(struct rproc *rproc, struct dma_buf *dmabuf, dma_addr_t *dma)
+{
+	struct rproc_dmabuf_entry *dmabuf_entry;
+
+	guard(mutex)(&rproc->lock);
+
+	dmabuf_entry = rproc_find_entry_for_dmabuf(rproc, dmabuf);
+	if (!dmabuf_entry)
+		return -EINVAL;
+
+	/* TODO: Should this be ->da? */
+	*dma = dmabuf_entry->dma;
+
+	return 0;
+}
+
+/**
+ * rproc_attach_dmabuf() - attach a DMA-BUF to rproc device
+ * @rproc: rproc handle
+ * @dmabuf: dmabuf entry to register
+ *
+ * This function attaches and maps specified DMUBUF to this rproc.
+ */
+int rproc_attach_dmabuf(struct rproc *rproc, struct dma_buf *dmabuf)
+{
+	struct rproc_dmabuf_entry *dmabuf_entry;
+	struct device *dev = &rproc->dev;
+	struct dma_buf_attachment *attachment;
+	struct sg_table *sgt;
+	int ret;
+
+	/* Prevent multiple entries in list for same dmabuf */
+	guard(mutex)(&rproc->lock);
+
+	/* Check if already in list */
+	dmabuf_entry = rproc_find_entry_for_dmabuf(rproc, dmabuf);
+	if (dmabuf_entry) {
+		dmabuf_entry->refcount++;
+		return 0;
+	}
+
+	attachment = dma_buf_attach(dmabuf, dev);
+	if (IS_ERR(attachment))
+		return PTR_ERR(attachment);
+
+	/* TODO: Move mapping to get_da()? */
+	sgt = dma_buf_map_attachment(attachment, DMA_BIDIRECTIONAL);
+	if (IS_ERR(sgt)) {
+		ret = PTR_ERR(sgt);
+		goto fail_detach;
+	}
+
+	/* FIXME: Only physically contiguous buffers currently supported */
+	if (sgt->orig_nents != 1) {
+		dev_err(dev, "DMA-BUF not contiguous\n");
+		ret =  -EINVAL;
+		goto fail_unmap;
+	}
+
+	dmabuf_entry = kzalloc(sizeof(*dmabuf_entry), GFP_KERNEL);
+	dmabuf_entry->len = sg_dma_len(sgt->sgl);
+	dmabuf_entry->dma = sg_dma_address(sgt->sgl);
+	/* TODO: Check this */
+//	rproc_pa_to_da(rproc, dmabuf_entry->dma, &dmabuf_entry->da);
+	dmabuf_entry->dmabuf = dmabuf;
+	dmabuf_entry->attachment = attachment;
+	dmabuf_entry->sgt = sgt;
+	dmabuf_entry->refcount = 1;
+
+	list_add_tail(&dmabuf_entry->node, &rproc->dmabufs);
+
+	return 0;
+
+fail_unmap:
+	dma_buf_unmap_attachment(attachment, sgt, DMA_BIDIRECTIONAL);
+fail_detach:
+	dma_buf_detach(dmabuf, attachment);
+	return ret;
+}
+EXPORT_SYMBOL(rproc_attach_dmabuf);
+
+static void rproc_release_dmabuf(struct rproc *rproc, struct rproc_dmabuf_entry *dmabuf_entry)
+{
+	if (dmabuf_entry->attachment && dmabuf_entry->sgt)
+		dma_buf_unmap_attachment(dmabuf_entry->attachment, dmabuf_entry->sgt, DMA_BIDIRECTIONAL);
+	if (dmabuf_entry->dmabuf && dmabuf_entry->attachment)
+		dma_buf_detach(dmabuf_entry->dmabuf, dmabuf_entry->attachment);
+	list_del(&dmabuf_entry->node);
+	kfree(dmabuf_entry);
+}
+
+int rproc_detach_dmabuf(struct rproc *rproc, struct dma_buf *dmabuf)
+{
+	struct rproc_dmabuf_entry *dmabuf_entry;
+
+	guard(mutex)(&rproc->lock);
+
+	dmabuf_entry = rproc_find_entry_for_dmabuf(rproc, dmabuf);
+	if (!dmabuf_entry)
+		return -EINVAL;
+
+	dmabuf_entry->refcount--;
+	if (dmabuf_entry->refcount < 1)
+		rproc_release_dmabuf(rproc, dmabuf_entry);
+
+	return 0;
+}
+EXPORT_SYMBOL(rproc_detach_dmabuf);
+
 /**
  * rproc_mem_entry_init() - allocate and initialize rproc_mem_entry struct
  * @dev: pointer on device struct
@@ -1221,6 +1345,7 @@
 void rproc_resource_cleanup(struct rproc *rproc)
 {
 	struct rproc_mem_entry *entry, *tmp;
+	struct rproc_dmabuf_entry *dmabuf, *dtmp;
 	struct rproc_debug_trace *trace, *ttmp;
 	struct rproc_vdev *rvdev, *rvtmp;
 	struct device *dev = &rproc->dev;
@@ -1256,6 +1381,10 @@
 		kfree(entry);
 	}
 
+	/* clean up dmabufs */
+	list_for_each_entry_safe(dmabuf, dtmp, &rproc->dmabufs, node)
+		rproc_release_dmabuf(rproc, dmabuf);
+
 	/* clean up remote vdev entries */
 	list_for_each_entry_safe(rvdev, rvtmp, &rproc->rvdevs, node)
 		platform_device_unregister(rvdev->pdev);
@@ -2494,6 +2623,18 @@
 		goto put_device;
 	}
 
+	/* Make device dma capable by inheriting from parent's capabilities */
+	set_dma_ops(&rproc->dev, get_dma_ops(rproc->dev.parent));
+	if (dma_coerce_mask_and_coherent(&rproc->dev, dma_get_mask(rproc->dev.parent)))
+		dev_warn(&rproc->dev, "Failed to set DMA mask. Trying to continue...\n");
+	rproc->dev.dma_parms = &rproc->dma_parms;
+	/*
+	 * We could use dma_get_max_seg_size(rproc->dev.parent) here but the
+	 * parent is not usually setup correctly either, use full 32bit mask
+	 * for now.
+	 */
+	dma_set_max_seg_size(&rproc->dev, DMA_BIT_MASK(32));
+
 	rproc->name = kstrdup_const(name, GFP_KERNEL);
 	if (!rproc->name)
 		goto put_device;
@@ -2511,6 +2652,7 @@
 	mutex_init(&rproc->lock);
 
 	INIT_LIST_HEAD(&rproc->carveouts);
+	INIT_LIST_HEAD(&rproc->dmabufs);
 	INIT_LIST_HEAD(&rproc->mappings);
 	INIT_LIST_HEAD(&rproc->traces);
 	INIT_LIST_HEAD(&rproc->rvdevs);
diff -Naur --no-dereference a/drivers/remoteproc/remoteproc_internal.h b/drivers/remoteproc/remoteproc_internal.h
--- a/drivers/remoteproc/remoteproc_internal.h	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/remoteproc/remoteproc_internal.h	2025-10-23 09:30:40.286462238 -0400
@@ -39,6 +39,26 @@
 	struct fw_rsc_vdev *rsc;
 };
 
+/**
+ * struct rproc_dmabuf_entry - dmabuf entry descriptor
+ * @va:	virtual address
+ * @dma: dma address
+ * @len: length, in bytes
+ * @da: device address
+ *
+ * @node: list node
+ */
+struct rproc_dmabuf_entry {
+	size_t len;
+	dma_addr_t dma;
+	u32 da;
+	struct dma_buf *dmabuf;
+	struct dma_buf_attachment *attachment;
+	struct sg_table *sgt;
+	size_t refcount;
+	struct list_head node;
+};
+
 static inline bool rproc_has_feature(struct rproc *rproc, unsigned int feature)
 {
 	return test_bit(feature, rproc->features);
